Index: /trunk/src/sh_mail.c
===================================================================
--- /trunk/src/sh_mail.c	(revision 584)
+++ /trunk/src/sh_mail.c	(revision 1)
@@ -855,10 +1218,12 @@
 #endif
 
-static int sh_mail_wait(int code, int ma_socket);
+static int sh_mail_wait(int code, FILE * m_socket);
 
 static char * relay_host = NULL;
 
-int sh_mail_set_relay (const char * str_s)
-{
+int sh_mail_set_relay (char * str_s)
+{
+  size_t i = 0;
+
   SL_ENTER(_("sh_mail_set_relay"));
 
@@ -867,16 +1232,18 @@
 
   if (relay_host != NULL)
-    {
-      SH_FREE (relay_host);
+    SH_FREE (relay_host);
+
+  if (0 == sl_strncmp(str_s, _("NULL"), 4))
+    {
       relay_host = NULL;
-    }
-
-  if (0 == sl_strncmp(str_s, _("NULL"), 4))
-    {
       SL_RETURN( 0, _("sh_mail_set_relay"));
     }
 
-  relay_host = sh_util_strdup(str_s);
-
+  i = sl_strlen(str_s) + 1;
+  relay_host = SH_ALLOC (i);
+  if (relay_host != NULL)
+    (void) sl_strlcpy(relay_host, str_s, i);
+  else
+    fprintf(stderr, _("ERROR:  sh_mail_set_relay: Out of memory"));
   SL_RETURN( 0, _("sh_mail_set_relay"));
 }
@@ -884,5 +1251,5 @@
 static char * mail_sender = NULL;
 
-int sh_mail_set_sender (const char *str)
+int sh_mail_set_sender (char *str)
 {
   if (mail_sender != NULL) 
@@ -902,42 +1269,16 @@
 }
 
-static int sh_mail_port = IPPORT_SMTP;
-
-int sh_mail_set_port (const char * str)
-{
-  int i = atoi (str);
-  
-  SL_ENTER(_("sh_mail_set_port"));
-  
-  if (i >= 0 && i < 65535)
-    { 
-      sh_mail_port = i;
-    }
-  else
-    {
-      sh_mail_port = IPPORT_SMTP;
-      SL_RETURN ((-1), _("sh_mail_set_port"));
-    }
-  
-  SL_RETURN( (0), _("sh_mail_set_port"));
-}
 
 /*************************
  *
  * start connection
- * for details on SMTP, see RFC 821
- *
- * If ma_address == NULL, will send to all marked with
- * send_mail=1 in recipient list, else to ma_address.   
+ * for details on SMTP, see RFC 821 
  */
 
 static time_t time_wait = 300;
-static void report_smtp (char * reply);
-
-static FILE * sh_mail_start_conn (struct alias * ma_address, 
-				  int * ma_socket, int * anum)
+
+static FILE * sh_mail_start_conn (int aFlag)
 {
   char       * address;
-  int          aFlag = 0;
 
   int          ecount;
@@ -952,7 +1293,4 @@
   FILE       * connFile = NULL;
   struct tm  * my_tm;
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-  struct tm    time_tm;
-#endif
   time_t       my_time;
   char         my_tbuf[128];
@@ -965,32 +1303,21 @@
   SL_ENTER(_("sh_mail_start_conn"));
 
-  *ma_socket = -1;
-  time_wait  = 300;
-
-  if (ma_address == NULL)
-    {
-      aFlag = 1;
-      ma_address = all_recipients;
-
-      while (ma_address)
-	{
-	  if (ma_address->send_mail == 1)
-	    break;
-	  ma_address = ma_address->all_next;
-	}
-    }
-
-  if (!ma_address)
+  time_wait = 300;
+
+  if (aFlag >= 0)
+    address = address_list[aFlag];
+  else
+    address = address_list[0];
+
+  TPT(( 0, FIL__, __LINE__, _("msg=<aFlag %d address %s>\n"), 
+	aFlag, address)); 
+
+  /* -------   split adress ------------------  */
+
+  if (0 == strcmp(address, _("NULL")))
     {
       SL_RETURN( NULL, _("sh_mail_start_conn"));
     } 
-
-  address = sh_string_str(ma_address->recipient);
-
-  TPT(( 0, FIL__, __LINE__, _("msg=<address %s>\n"), 
-	address)); 
-
-  /* -------   split adress ------------------  */
-
+    
   if (strchr (address, '@') == NULL) {
     (void) sl_strlcpy(ma_user,    address,     256);
@@ -1002,5 +1329,5 @@
       ++i;
     }
-    
+
     /* adress[i] = '@' 
      */
@@ -1024,16 +1351,10 @@
       TPT((0, FIL__, __LINE__, _("msg=<user %s machine %s>\n"), 
 	   ma_user, ma_machine)); 
-      fd = connect_port (ma_machine, sh_mail_port, 
+      fd = connect_port (ma_machine, IPPORT_SMTP, 
 			 error_call, &error_num, error_msg, 256);
     }
   else
     {
-      answers = ma_address->mx_list;
-      if (!answers)
-	{
-	  answers = return_mx (ma_machine);
-	  ma_address->mx_list = answers;
-	}
-
+      answers = return_mx (ma_machine);
       if (answers)
 	{
@@ -1047,9 +1368,10 @@
 		   _("msg=<user %s mx %s pref %d>\n"), 
 		   ma_user, ma_machine, result[i].pref));
-	      fd = connect_port (ma_machine, sh_mail_port, 
+	      fd = connect_port (ma_machine, IPPORT_SMTP, 
 				 error_call, &error_num, error_msg, 256);
 	      if (fd >= 0)
 		break;
 	    }
+	  (void) free_mx(answers);
 	}
       else
@@ -1078,5 +1400,5 @@
     {
       TPT(( 0, FIL__, __LINE__, _("msg=<fdopen() failed>\n")));
-      (void) sl_close_fd(FIL__, __LINE__, fd);
+      (void) close(fd);
       SL_RETURN( NULL, _("sh_mail_start_conn"));
     }
@@ -1085,5 +1407,5 @@
   /* say HELO to the other socket
    */
-  if (0 == sh_mail_wait (220, fd)) 
+  if (0 == sh_mail_wait (220, connFile)) 
     {
       sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_NET, 
@@ -1092,5 +1414,5 @@
 		      _("mail"), sh.host.name);
       TPT(( 0, FIL__, __LINE__, _("msg=<Timeout>\n")));
-      (void) sl_fclose(FIL__, __LINE__, connFile);
+      (void) fclose(connFile);
       SL_RETURN( NULL, _("sh_mail_start_conn"));
     }
@@ -1098,17 +1420,15 @@
   (void) fflush(connFile);
 
-  if (0 != sh_ipvx_is_numeric(sh.host.name))
-    {
-      sl_snprintf(error_msg, sizeof(error_msg), "HELO [%s]", 
-		  sh.host.name);
+  if (0 != is_numeric(sh.host.name))
+    {
+      TPT(( 0, FIL__, __LINE__, _("msg=<HELO [%s]>%c%c"), 
+	    sh.host.name, 13, 10));
     }
   else
     {
-      sl_snprintf(error_msg, sizeof(error_msg), "HELO %s", 
-		  sh.host.name);
-    }
-  report_smtp(error_msg);
-
-  if (0 != sh_ipvx_is_numeric(sh.host.name))
+      TPT(( 0, FIL__, __LINE__, _("msg=<HELO %s>%c%c"), 
+	    sh.host.name, 13, 10));
+    }
+  if (0 != is_numeric(sh.host.name))
     fprintf(connFile, _("HELO [%s]%c%c"), sh.host.name, 13, 10);
   else
@@ -1117,5 +1437,5 @@
   (void) fflush(connFile);
 
-  if (0 == sh_mail_wait(250, fd)) 
+  if (0 == sh_mail_wait(250, connFile)) 
     {
       sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_NET, 
@@ -1124,5 +1444,5 @@
 
       TPT(( 0, FIL__, __LINE__, _("msg=<Timeout.>\n")));
-      (void) sl_fclose(FIL__, __LINE__, connFile);
+      (void) fclose(connFile);
       SL_RETURN( NULL, _("sh_mail_start_conn"));
     }
@@ -1135,5 +1455,5 @@
     {
       (void) sl_strlcat (this_address, "@", 256);
-      if (0 != sh_ipvx_is_numeric(sh.host.name))
+      if (0 != is_numeric(sh.host.name))
 	(void) sl_strlcat (this_address, _("example.com"), 256);
       else
@@ -1141,7 +1461,6 @@
     }
 
-  sl_snprintf(error_msg, sizeof(error_msg), "MAIL FROM:<%s>", 
-	      this_address);
-  report_smtp(error_msg);
+  TPT(( 0, FIL__, __LINE__,  _("msg=<MAIL FROM:<%s>>%c%c"), 
+	this_address, 13, 10));
 
   (void) fflush(connFile);
@@ -1151,5 +1470,5 @@
   (void) fflush(connFile);
 
-  if (0 == sh_mail_wait(250, fd)) 
+  if (0 == sh_mail_wait(250, connFile)) 
     {
       sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_NET, 
@@ -1157,5 +1476,5 @@
 		      _("mail"), this_address);
       TPT(( 0, FIL__, __LINE__, _("msg=<Timeout.>\n")));
-      (void) sl_fclose(FIL__, __LINE__, connFile);
+      (void) fclose(connFile);
       SL_RETURN( NULL, _("sh_mail_start_conn"));
     }
@@ -1163,9 +1482,8 @@
   /* tell them who to send mail to
    */
-  if (aFlag == 0)
-    {
-      sl_snprintf(error_msg, sizeof(error_msg), "RCPT TO:<%s>", 
-		  address);
-      report_smtp(error_msg);
+  if (aFlag >= 0)
+    {
+      TPT(( 0, FIL__, __LINE__,  _("msg=<RCPT TO:<%s>>%c%c"), 
+	    address, 13, 10)); 
 
       (void) fflush(connFile);
@@ -1173,5 +1491,5 @@
       (void) fflush(connFile);
 
-      if (0 == sh_mail_wait(250, fd)) 
+      if (0 == sh_mail_wait(250, connFile)) 
 	{
 	  sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_NET, 
@@ -1179,52 +1497,35 @@
 			  _("mail"), address);
 	  TPT(( 0, FIL__, __LINE__, _("msg=<Timeout.>\n")));
-	  (void) sl_fclose(FIL__, __LINE__, connFile);
+	  (void) fclose(connFile);
 	  SL_RETURN( NULL, _("sh_mail_start_conn"));
 	}
-      *anum = 1;
     }
   else
     {
-      int address_num = 0;
-      ecount      = 0;
-
-      ma_address = all_recipients;
-
-      while (ma_address)
-	{
-	  if (ma_address->send_mail != 1)
-	    {
-	      ma_address = ma_address->next;
-	      continue;
-	    }
-
-	  ++address_num;
-
-	  sl_snprintf(error_msg, sizeof(error_msg), "RCPT TO:<%s>", 
-		      sh_string_str(ma_address->recipient));
-	  report_smtp(error_msg);
+      ecount = 0;
+      for (i = 0; i < address_num; ++i)
+	{
+	  if (address_list[i] == NULL)  /* paranoia */
+	    break;
+	  TPT(( 0, FIL__, __LINE__,  _("msg=<RCPT TO:<%s>>%c%c"), 
+		address_list[i], 13, 10)); 
 	  
 	  (void) fflush(connFile);
-	  fprintf(connFile, _("RCPT TO:<%s>%c%c"), 
-		  sh_string_str(ma_address->recipient), 13, 10); 
+	  fprintf(connFile, _("RCPT TO:<%s>%c%c"), address_list[i], 13, 10); 
 	  (void) fflush(connFile);
 	  
-	  if (0 == sh_mail_wait(250, fd)) 
+	  if (0 == sh_mail_wait(250, connFile)) 
 	    {
 	      sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_NET, 
 			      _("RCPT TO failed"), _("sh_mail_start_conn"), 
-			      _("mail"), sh_string_str(ma_address->recipient));
+			      _("mail"), address_list[i]);
 
 	      TPT(( 0, FIL__, __LINE__, _("msg=<Timeout.>\n")));
 	      ++ecount;
 	    }
-	  ma_address = ma_address->next;
-	}
-
-      *anum += address_num;
-
+	}
       if (ecount == address_num)
 	{
-	  (void) sl_fclose(FIL__, __LINE__, connFile);
+	  (void) fclose(connFile);
 	  SL_RETURN( NULL, _("sh_mail_start_conn"));
 	}
@@ -1233,5 +1534,5 @@
   /* Send the message 
    */
-  report_smtp(_("DATA"));
+  TPT(( 0, FIL__, __LINE__,  _("msg=<DATA>%c%c"), 13, 10)); 
 
   (void) fflush(connFile);
@@ -1239,5 +1540,5 @@
   (void) fflush(connFile);
 
-  if (0 == sh_mail_wait(354, fd)) 
+  if (0 == sh_mail_wait(354, connFile)) 
     {
       sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_NET, 
@@ -1245,5 +1546,5 @@
 		      _("mail"), address);
       TPT(( 0, FIL__, __LINE__, _("msg=<Timeout.>\n")));
-      (void) sl_fclose(FIL__, __LINE__, connFile);
+      (void) fclose(connFile);
       SL_RETURN( NULL, _("sh_mail_start_conn"));
     }
@@ -1251,27 +1552,9 @@
 
   my_time = time(NULL);
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-  my_tm = localtime_r(&my_time, &time_tm);
-#else
-  my_tm = localtime(&my_time);
-#endif
-  
-  if (!my_tm) 
-    {
-      sl_strlcpy(my_tbuf, _("Thu, 01 Jan 1970 00:00:00 +00:00"), sizeof(my_tbuf));
-    }
-  else
-    {
-#if defined(HAVE_STRFTIME_Z)
-      (void) strftime(my_tbuf, 127, _("%a, %d %b %Y %H:%M:%S %z"), my_tm);
-#else
-      (void) strftime(my_tbuf, 127, _("%a, %d %b %Y %H:%M:%S %Z"), my_tm);
-#endif
-    }
+  my_tm   = localtime(&my_time);
+  (void)    strftime(my_tbuf, 127, _("%a, %d %b %Y %H:%M:%S %Z"), my_tm);
 
   TPT(( 0, FIL__, __LINE__,  _("msg=<From: <%s>%c%cTo: <%s>%c%cDate: %s>%c%c"),
 	this_address, 13, 10, address, 13, 10, my_tbuf, 13, 10));
-
-  report_smtp(_("sending data.."));
 
   (void) fflush(connFile);
@@ -1284,5 +1567,4 @@
 	  my_tbuf, 13, 10);
 
-  *ma_socket = fd;
   SL_RETURN( connFile, _("sh_mail_start_conn"));
 }
@@ -1294,11 +1576,9 @@
  */
 
-static int sh_mail_end_conn (FILE * connFile, int fd)
+static int sh_mail_end_conn (FILE * connFile)
 {
   SL_ENTER(_("sh_mail_end_conn"));
 
   time_wait = 300;
-
-  report_smtp(_("."));
 
   (void) fflush(connFile);
@@ -1306,5 +1586,7 @@
   (void) fflush(connFile);
 
-  if (0 != sh_mail_wait(250, fd))
+  TPT(( 0, FIL__, __LINE__, _("msg=<message end written>\n")));
+
+  if (0 != sh_mail_wait(250, connFile))
     {  
       (void) fflush(connFile);
@@ -1333,32 +1615,21 @@
  *
  */
-extern int flag_err_debug;
-
-static void report_smtp (char * reply)
-{
-  char * tmp;
-
-  if (flag_err_debug == S_TRUE)
-    {
-      tmp = sh_util_safe_name_keepspace(reply);
-
-      sh_error_handle (SH_ERR_ALL, FIL__, __LINE__, 0, MSG_E_SUBGEN,
-		       tmp,
-		       _("report_smtp") );
-      SH_FREE(tmp);
-    }
-  return;
-}
-
-
-static int sh_mail_wait(int code, int ma_socket)
+
+static jmp_buf wait_timeout;
+
+static void sh_mail_alarmhandle (int mysignal)
+{
+  /*@-noeffect@*/
+  (void) mysignal; /* avoid compiler warning */
+  /*@+noeffect@*/
+
+  longjmp(wait_timeout, 1);
+}
+
+static int sh_mail_wait(int code, FILE * ma_socket)
 {
   int rcode, g;
 
-  char c;
-
-  char errmsg[194];
-  char reply[128];
-  unsigned int  ireply = 0;
+  char errmsg[128];
 
   enum { 
@@ -1371,36 +1642,53 @@
   time_t waited_time;
 
+  struct   sigaction          old_act;
+  volatile unsigned int       old_alarm = 0;
+
+  struct  sigaction  new_act;
+  sigset_t           unblock;
+
+  (void) sigemptyset(&unblock);
+  (void) sigaddset  (&unblock, SIGALRM);
+
+  new_act.sa_handler = sh_mail_alarmhandle;
+  (void) sigemptyset( &new_act.sa_mask );       /* set an empty mask       */
+  new_act.sa_flags = 0;                         /* init sa_flags           */
+
   SL_ENTER(_("mail_wait"));
   
+  /* alarm was triggered
+   */
+  if (setjmp(wait_timeout) != 0)
+    {
+      (void) alarm(0);
+      (void) sigaction (SIGALRM, &old_act, NULL);
+      (void) alarm(old_alarm);
+      (void) sigprocmask(SIG_UNBLOCK, &unblock, NULL);
+      TPT((0, FIL__, __LINE__, _("msg=<mail_wait: timeout>\n"))); 
+      SL_RETURN( 0, _("mail_wait"));
+    }
+
   waited_time = time(NULL);
 
   /* timeout after 5 minutes
    */
-
-  rcode    = 0;
-  state    = WAIT_CODE_START;
-  reply[0] = '\0';
-
-  while (sl_read_timeout_fd (ma_socket, &c, 1, time_wait, S_FALSE) > 0) {
-
-    if (ireply < (sizeof(reply) - 1))
+  old_alarm = alarm(0);
+  (void) sigaction (SIGALRM, &new_act, &old_act);
+  (void) alarm((unsigned int) time_wait);
+
+  rcode = 0;
+  state = WAIT_CODE_START;
+
+  while (0 == feof(ma_socket) && 0 == ferror(ma_socket)) {
+
+    if ( (g=fgetc(ma_socket)) == EOF)
       {
-	if (c != '\n' && c != '\r')
-	  {
-	    reply[ireply] = c;
-	    ++ireply;
-	    reply[ireply] = '\0';
-	  }
-      }
-
-    g = (int) c;
-
-    /*
-    if (g == EOF)
-      {
+	(void) alarm(0);
+	(void) sigaction (SIGALRM, &old_act, NULL); 
+	(void) alarm(old_alarm);
+	(void) sigprocmask(SIG_UNBLOCK, &unblock, NULL);
 	TPT((0, FIL__, __LINE__, _("msg=<mail_wait: EOF>\n"))); 
 	SL_RETURN( 0, _("mail_wait")); 
       }
-    */
 
     switch(state) {
@@ -1411,9 +1699,6 @@
       if (0 != isspace(g))
 	break;             /* Skip white space                    */
-      if (0 == isdigit(g)) 
-	{
-	  report_smtp(reply);
-	  SL_RETURN( 0, _("mail_wait")); /* No leading number     */
-	}
+      if (0 == isdigit(g))
+	return 0;          /* No leading number                   */
       rcode = g-(int)'0';  /* convert to number                   */
       state = WAIT_CODE;
@@ -1439,4 +1724,8 @@
 	break;
       /*@-charintliteral@*/
+      (void) alarm(0);
+      (void) sigaction (SIGALRM, &old_act, NULL); 
+      (void) alarm(old_alarm);
+      (void) sigprocmask(SIG_UNBLOCK, &unblock, NULL);
 
       TPT((0, FIL__, __LINE__, 
@@ -1446,16 +1735,11 @@
       if (g != 1)
 	{
-	  char * tmp = sh_util_safe_name_keepspace(reply);
-          sl_snprintf(errmsg, sizeof(errmsg),
-		      _("Bad response (%s), expected %d"), tmp, code);
-	  SH_FREE(tmp);
-
+	  /*@-bufferoverflowhigh@*/
+          sprintf(errmsg,                              /* known to fit  */
+		  _("Bad response (%d), expected %d"), rcode, code);
+	  /*@+bufferoverflowhigh@*/
 	  sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_NET, 
 			  errmsg, _("sh_mail_wait"), 
 			  _("mail"), _("SMTP server"));
-	}
-      else
-	{
-	  report_smtp(reply);
 	}
       waited_time = time(NULL) - waited_time;
@@ -1477,7 +1761,10 @@
       
     default:
+      (void) alarm(0);
+      (void) sigaction (SIGALRM, &old_act, NULL); 
+      (void) alarm(old_alarm);
+      (void) sigprocmask(SIG_UNBLOCK, &unblock, NULL);
 
       TPT((0, FIL__, __LINE__, _("msg=<mail_wait: bad>\n"))); 
-      report_smtp(reply);
       SL_RETURN( 0, _("mail_wait")); 
       
@@ -1485,8 +1772,12 @@
   }
 
+  (void) alarm(0);                            /* Disable alarm       */
+  (void) sigaction (SIGALRM, &old_act, NULL); 
+  (void) alarm(old_alarm);
+  (void) sigprocmask(SIG_UNBLOCK, &unblock, NULL);
+
   TPT((0, FIL__, __LINE__, _("msg=<mail_wait: failed>\n"))); 
 
   /* Failed, EOF or error on socket */
-  report_smtp(reply);
   SL_RETURN( 0, _("mail_wait")); 
 }
@@ -1497,5 +1788,5 @@
 #define SPLIT_AT 998
 
-static char * split_string(const char * str)
+static char * split_string(char * str)
 {
   size_t size;
@@ -1504,26 +1795,17 @@
 
   char * p, * p0;
-  const char * q;
+  char * q;
 
   if (!str)
     return NULL;
 
-  size   = strlen(str) + 1;
+  size   = strlen(str);
+  /* fprintf(stderr, "orig = %d\n", size); */
   blocks = 1 + (size / SPLIT_AT);
   
-  if (sl_ok_muls(2, blocks) && sl_ok_adds(size, (2*blocks)))
-    {
-      size   = size + (2*blocks);
-    }
-  else
-    {
-      /* integer overflow, do not split */
-      p = sh_util_strdup(str);
-      return p;
-    }
-
+  size   = size + (2*blocks) + 1;
   p = SH_ALLOC(size);
   memset(p, 0, size);
-
+  /* fprintf(stderr, "alloc = %d\n", size); */
   p0 = p;
 
@@ -1601,5 +1883,4 @@
   int  ret, length, status;
   mx * result;
-  size_t len;
 
   typedef union
@@ -1609,10 +1890,9 @@
   } querybuf;
 
-  querybuf * reply;
+  querybuf reply;
   char expanded[1024];
   unsigned char * comp_dn, * eom;
   HEADER * header;
-  int      type, rdlength, pref;
-  unsigned int count, theindex;
+  int      count, index, type, rdlength, pref;
   dnsrep * retval;
 
@@ -1622,14 +1902,9 @@
     SL_RETURN (NULL, _("get_mx"));
 
-  reply = SH_ALLOC(sizeof(querybuf));
-
   errno = 0;
   length = res_query (hostname, C_IN, T_MX, 
-		      (unsigned char *) reply, 4095);
-
+		      (unsigned char *) &reply, 4095);
   if (length < 1)
     {
-      char errbuf[SH_ERRBUF_SIZE];
-
       /* error handling
        */
@@ -1644,28 +1919,27 @@
 	  sh_error_handle (SH_ERR_ALL, FIL__, __LINE__, status, MSG_E_SUBGEN,
 			   (errno == ECONNREFUSED) ? 
-			   sh_error_message (status, errbuf, sizeof(errbuf)) : 
-			   sh_tools_errmessage(status, errbuf, sizeof(errbuf)),
+			   sh_error_message (status) : 
+			   sh_tools_errmessage(status),
 			   _("res_query"));
 #else
 	  if (errno == ECONNREFUSED)
-	    fprintf(stderr, " ERROR: %s: \n", strerror(errno)); /* TESTONLY */
+	    fprintf(stderr, " ERROR: %s: \n", strerror(errno));
 	  else
-	    fprintf(stderr, "HERROR: %s\n", hstrerror(h_errno));/* TESTONLY */
+	    fprintf(stderr, "HERROR: %s\n", hstrerror(h_errno));
 #endif
 	}
-      SH_FREE(reply);
       SL_RETURN (NULL, _("get_mx"));
     }
 
-
-  header  = (HEADER *) reply;
+  ret = 0;
+  header  = (HEADER *) &reply;
 
   /* start of data section
    */
-  comp_dn = (unsigned char *) reply + HFIXEDSZ;
+  comp_dn = (unsigned char *) &reply + HFIXEDSZ;
 
   /* end-of-message
    */
-  eom     = (unsigned char *) reply + length;
+  eom     = (unsigned char *) &reply + length;
 
   /* HEADER NAME  -- must be skipped or decompressed
@@ -1683,48 +1957,28 @@
    */
   count = ntohs (header->qdcount); 
-  for (theindex = 0; theindex < count; ++theindex)
+  for (index = 0; index < count; ++index)
     {
       ret = dn_skipname (comp_dn, eom);
       comp_dn += ret + QFIXEDSZ;
       if (ret < 1 || comp_dn >= eom)
-	{
-	  SH_FREE(reply);
-	  SL_RETURN (NULL, _("get_mx"));
-	}
-    }
-
+	SL_RETURN (NULL, _("get_mx"));
+    }
   count         = ntohs (header->ancount);
   if (count < 1)
-    {
-      SH_FREE(reply);
-      SL_RETURN (NULL, _("get_mx"));
-    }
+    SL_RETURN (NULL, _("get_mx"));
 
   retval        = SH_ALLOC (sizeof (dnsrep));
   if (!retval)
-    {
-      SH_FREE(reply);
-      SL_RETURN (NULL, _("get_mx"));
-    }
-
+    SL_RETURN (NULL, _("get_mx"));
   retval->count = count;
 
   /* allocate space for the results */
 
-  if (!sl_ok_muls(count, sizeof (mx)))
-    {
-      SH_FREE(reply);
+  result        = SH_ALLOC (count * sizeof (mx));
+  if (!result)
+    {
       SH_FREE   (retval);
       SL_RETURN (NULL, _("get_mx"));
     }
-
-  result        = SH_ALLOC (count * sizeof (mx));
-  
-  if (!result)
-    {
-      SH_FREE(reply);
-      SH_FREE   (retval);
-      SL_RETURN (NULL, _("get_mx"));
-    }
   retval->reply = result;
 
@@ -1733,10 +1987,9 @@
       /* HEADER NAME 
        */
-      ret = dn_expand ((unsigned char *) reply, eom, comp_dn, 
+      ret = dn_expand ((unsigned char *) &reply, eom, comp_dn, 
 		       (char *) expanded, 1023);
       comp_dn += ret;
       if (ret < 1 || comp_dn >= eom)
 	{
-	  SH_FREE(reply);
 	  SH_FREE (result);
 	  SH_FREE (retval);
@@ -1750,5 +2003,4 @@
       if (type != T_MX || comp_dn >= eom)
 	{
-	  SH_FREE(reply);
 	  SH_FREE (result);
 	  SH_FREE (retval);
@@ -1756,17 +2008,14 @@
 	}
 
-
       /* CLASS (re-use 'type' var)
        */
-      /* type = get_short (comp_dn); *//* don't care */
+      type = get_short (comp_dn);
       comp_dn += 2;
       if (comp_dn >= eom)
 	{
-	  SH_FREE(reply);
 	  SH_FREE (result);
 	  SH_FREE (retval);
 	  SL_RETURN (NULL, _("get_mx"));
 	}
-
 
       /* TTL
@@ -1775,5 +2024,4 @@
       if (comp_dn >= eom)
 	{
-	  SH_FREE(reply);
 	  SH_FREE (result);
 	  SH_FREE (retval);
@@ -1787,5 +2035,4 @@
       if (rdlength < 1 || comp_dn >= eom)
 	{
-	  SH_FREE(reply);
 	  SH_FREE (result);
 	  SH_FREE (retval);
@@ -1799,5 +2046,4 @@
       if (comp_dn >= eom)
 	{
-	  SH_FREE(reply);
 	  SH_FREE (result);
 	  SH_FREE (retval);
@@ -1805,10 +2051,9 @@
 	}
 
-      ret = dn_expand ((unsigned char *) reply, eom, comp_dn, 
+      ret = dn_expand ((unsigned char *) &reply, eom, comp_dn, 
 		       (char *) expanded, 1023);
       comp_dn += ret;
       if (ret < 1)
 	{
-	  SH_FREE(reply);
 	  SH_FREE (result);
 	  SH_FREE (retval);
@@ -1820,11 +2065,9 @@
        */
       result[count].pref = pref;
-      len = strlen (expanded) + 1;
-      result[count].address = SH_ALLOC (len);
-      sl_strlcpy (result[count].address, expanded, len);
+      result[count].address = SH_ALLOC (strlen (expanded) + 1);
+      strcpy (result[count].address, expanded);        /* known to fit  */
     }
   while (ret > 0 && comp_dn < eom && count);
 
-  SH_FREE(reply);
   SL_RETURN (retval, _("get_mx"));
 }
@@ -1854,9 +2097,9 @@
 static dnsrep * return_mx (char *domain)
 {
+  struct hostent *host = NULL;
   dnsrep * answers = NULL;
   mx     * result;
   dnsrep * retval;
-  char   * address = NULL;
-  char     errmsg[128];
+  char     errmsg[128]; 
 
   SL_ENTER(_("return_mx"));
@@ -1875,6 +2118,4 @@
   else
     {
-      char numeric[SH_IP_BUF];
-
       if (domain != NULL)
 	{
@@ -1887,5 +2128,4 @@
 			   _("get_mx"));
 #else
-	  /* flawfinder: ignore *//* test code only */
 	  strcpy  (errmsg,                               /* known to fit  */
 		   _("No MX record for domain "));
@@ -1896,21 +2136,7 @@
 #endif
 	}
-
-      retval = NULL;
-
       if (domain != NULL)
-	address = sh_ipvx_canonical(domain, numeric, sizeof(numeric));
-
-      if (address)
-	{
-	  result       = SH_ALLOC (sizeof (mx));
-	  retval       = SH_ALLOC (sizeof (dnsrep));
-	  retval->reply = result;
-	  retval->count = 1;
-	  result->pref  = 0;
-
-	  result->address = address;
-	}
-      else
+	host = /*@-unrecog@*/sh_gethostbyname (domain)/*@+unrecog@*/;
+      if (!host)
 	{
 #ifdef FIL__
@@ -1923,10 +2149,18 @@
 	  SL_RETURN (NULL, _("return_mx"));
 	}
-
+      result       = SH_ALLOC (sizeof (mx));
+      retval       = SH_ALLOC (sizeof (dnsrep));
+      retval->reply = result;
+      retval->count = 1;
+      result->pref  = 0;
+      /*@-type@*/
+      result->address = SH_ALLOC (strlen (host->h_name) + 1);
+      strcpy (result->address, host->h_name);          /* known to fit  */
+      /*@+type@*/
       SL_RETURN (retval, _("return_mx"));
     }
 }
 
-int free_mx (dnsrep * answers)
+static int free_mx (dnsrep * answers)
 {
   mx     * result;
